function[num,den,success] =   make_iir_filter()
%========================================================================

%Copyright (c) 1999-2000 The University of Texas
%All Rights Reserved.
 
%This program is free software; you can redistribute it and/or modify
%it under the terms of the GNU General Public License as published by
%the Free Software Foundation; either version 2 of the License, or
%(at your option) any later version.
 
%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.
 
%The GNU Public License is available in the file LICENSE, or you
%can write to the Free Software Foundation, Inc., 59 Temple Place -
%Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
%World Wide Web at http://www.fsf.org.

 %Demo ideas : Dr.Alan C Bovik
 %Programmer :	Umesh Rajashekar 
 %Version:        %W%	%G%

%The authors are with the Department of Electrical and Computer
%Engineering, The University of Texas at Austin, Austin, TX.
%They can be reached at bovik@ece.utexas.edu and umesh@ece.utexas.edu

%Kindly report any suggestions or corrections to the demos to 
%umesh@ece.utexas.edu

%========================================================================
num =[];
den = [];

hndl = gcbf;
%get the handles for the filters

name_hndl =  findobj ( hndl , 'Tag' , 'fil_name');
type_hndl =  findobj ( hndl , 'Tag' , 'fil_type');
pbr_hndl = findobj ( hndl , 'Tag' , 'Edit_psr');
sbr_hndl = findobj ( hndl , 'Tag' , 'Edit_sbr');

f1_hndl = findobj ( hndl , 'Tag' , 'Slider_f1');
f2_hndl = findobj ( hndl , 'Tag' , 'Slider_f2');
f3_hndl = findobj ( hndl , 'Tag' , 'Slider_f3');
f4_hndl = findobj ( hndl , 'Tag' , 'Slider_f4');

order_hndl =  findobj ( hndl , 'Tag' , 'Radio_manual');
disp_auto =   findobj ( hndl , 'Tag' , 'Static_auto');


fil_name = get (name_hndl, 'UserData');
fil_type = get (type_hndl, 'UserData');
Rp = get (pbr_hndl, 'UserData'); %passband ripple
Rs = get (sbr_hndl, 'UserData'); %stopband ripple

f1 = get (f1_hndl, 'UserData');
f2 = get (f2_hndl, 'UserData');
f3 = get (f3_hndl, 'UserData');
f4 = get (f4_hndl, 'UserData');

success = chk_vals ( fil_type , f1 , f2, f3 , f4);
if(~ success)
   return
end



fil_order = get_iir_order;

if (not (isempty(fil_order)))
   
	if ( fil_order == -1 )
   	success = 0;
   end
end



%failed to make filter
if (success == 0)
   num = [];
   den = [];
   return;
end

   
   %freq vals all perfect
   
   %group the freq into arrays
   
   [Wp Ws] = make_bands(fil_type ,f1,f2,f3,f4);
%   Wp = [fil_pb1 fil_pb2];
%   Ws = [fil_sb1 fil_sb2];


      
      
      

      switch (fil_name)
      
   case('Butterworth'),
      [num,den,auto_order] = BW_filt (fil_type,Rs,Rp,Ws,Wp,fil_order);
      
   case('Cheby-1'),
      [num,den,auto_order] = Cheby1_filt (fil_type,Rs,Rp,Ws,Wp,fil_order);

	case('Cheby-2'),
      [num,den,auto_order] = Cheby2_filt (fil_type,Rs,Rp,Ws,Wp,fil_order);

	case('Elliptical'),
      [num,den,auto_order] = Ellip_filt (fil_type,Rs,Rp,Ws,Wp,fil_order);
         
   end

set (disp_auto , 'String' , num2str(auto_order));
      
      
   
 
 
   


















